import { world, system } from "@minecraft/server"

system.events.beforeWatchdogTerminate.subscribe(data => {
	data.cancel = true;
});
world.events.tick.subscribe(active =>{
	let w = world.getDimension("overworld"); 

	for (let p of world.getPlayers()) {
		p.runCommandAsync(`function shield`);

		let shield_o_m = ["iron_offhand", "netherite_offhand", "diamond_offhand", "iron_mainhand", "diamond_mainhand", "netherite_mainhand", "copper_mainhand", "copper_offhand"]

		for(let s_m_o of shield_o_m){
			if (!p.hasTag(s_m_o)) {
				p.runCommandAsync(`effect @s resistance 0 0 true`)
				p.removeTag("iron_shield");
				p.removeTag("diamond_shield");
				p.removeTag("netherite_shield");
				p.removeTag("copper_shield");
			}
		}

		//Shield Using
		if(p.hasTag("attack")){
			p.runCommandAsync(`effect @s resistance 0 0 true`);
		}
		if(p.isSneaking && !p.hasTag("attack")){
			if (p.hasTag("iron_offhand") || p.hasTag("iron_mainhand")) {
				p.addTag("iron_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("netherite_offhand") || p.hasTag("netherite_mainhand")) {
				p.addTag("netherite_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("copper_offhand") || p.hasTag("copper_mainhand")) {
				p.addTag("copper_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
			if (p.hasTag("diamond_offhand") || p.hasTag("diamond_mainhand")) {
				p.addTag("diamond_shield");
				p.runCommandAsync(`effect @s resistance 1 255 true`);
			}
		}
		if(!p.isSneaking){
			if (!p.hasTag("diamond_offhand") && !p.hasTag("diamond_mainhand")) {
				p.removeTag("diamond_shield");
			}
			if (!p.hasTag("iron_offhand") && !p.hasTag("iron_mainhand")) {
				p.removeTag("iron_shield");
			}
			if (!p.hasTag("netherite_offhand") && !p.hasTag("netherite_mainhand")) {
				p.removeTag("netherite_shield");
			}
			if (!p.hasTag("copper_offhand") && !p.hasTag("copper_mainhand")) {
				p.removeTag("copper_shield");
			}
		}
	}

});


world.events.entityHurt.subscribe(hurt =>{

	let eHurt = hurt.hurtEntity;
	let damaging = hurt.damageSource;

	if(hurt.damageSource.cause == "projectile" || hurt.damageSource.cause == "entityAttack" || hurt.damageSource.cause == "entityExplosion" || hurt.damageSource.cause == "blockExplosion"){
		if(eHurt.hasTag("iron_shield") || eHurt.hasTag("diamond_shield") || eHurt.hasTag("netherite_shield") || eHurt.hasTag("copper_shield")){
			eHurt.runCommandAsync(`tp ${eHurt.name} ~ ~ ~`);
			eHurt.runCommandAsync(`playsound random.gem_shield @s ~~~`);
			eHurt.runCommandAsync(`summon new:knockback_shield ~~~`);

		}
	}
	try{
		
		if(eHurt.typeId == "minecraft:player" && !eHurt.hasTag("iron_shield") && !eHurt.hasTag("diamond_shield") && !eHurt.hasTag("netherite_shield") && !eHurt.hasTag("copper_shield")){

			eHurt.runCommandAsync(`playsound game.player.hurt @p ~~~ 4 1 4`)
		}

		if(damaging.hasTag("iron_shield") || damaging.hasTag("diamond_shield") ||damaging.hasTag("netherite_shield") ||damaging.hasTag("copper_shield")){
			damaging.runCommandAsync(`tag @s add attack`);
		}
	}
	catch(e){
	}


})